<template>
  <div class="drawer_menu">
    <el-drawer
      v-model="drawer"
      :show-close="false"
      size="100%"
      custom-class="w-full bg-primary drawer-menu"
      class="bg-primary"
    >
      <template #title>
        <div class="logo">
          <div
            class="flex items-center justify-center w-full h-full"
            @click="goHome"
          >
            <img
              class="object-contain w-[125px] h-auto opacity-100 visible"
              :src="bigLogo.ImagePath"
              alt=""
            />
          </div>
        </div>
      </template>
      <div class="flex h-full w-full overflow-auto border-0">
        <div class="flex flex-col w-full px-4 pb-16 border-0 h-[calc(100%-65px)] overflow-y-auto">
          <div class="relative flex flex-wrap justify-between mt-4 mb-6">
            <div class="flex flex-wrap justify-between w-full mt-3">
              <div class="w-full mb-4 relative h-[40px]">
                <div
                  class="box-shadow-inset flex items-center bg-[var(--button-bg)] rounded-lg h-full"
                  @click="openGameSearchModal"
                >
                  <div class="flex items-center icon-search">
                    <font-awesome-icon icon="magnifying-glass" class="pl-3" />
                    <span
                      class="visible indent-0 opacity-100 text-[var(--font-color-primary)] text-sm pl-4"
                    >
                      {{ $t("search") }}...
                    </span>
                  </div>
                </div>
              </div>
              <div
                class="w-full ml-0 flex items-center h-[40px] text-sm py-0 px-4 bg-[var(--button-bg)] border-[var(--element-border-color)] border-[1px] box-shadow rounded-lg mb-4"
                @click="gameTypeDialogVisible = true"
              >
                <img
                  class="w-5 h-5 align-middle border-0"
                  :src="
                    getAssetImage(
                      `assets/theme/black_modern_1/images/sidebar/games-type.png`
                    )
                  "
                  alt=""
                />
                <span
                  class="relative w-full max-w-full overflow-hidden opacity-100 left-5"
                  >{{ $t("game_types") }}</span
                >
                <font-awesome-icon
                  icon="arrow-right"
                  class="flex items-center justify-center opacity-100"
                />
              </div>
              <div
                class="w-full ml-0 flex items-center h-[40px] text-sm py-0 px-4 bg-[var(--button-bg)] border-[var(--element-border-color)] border-[1px] box-shadow rounded-lg mb-4"
                @click="dialogVisible = true"
              >
                <img
                  class="w-5 h-5 align-middle border-0"
                  :src="
                    getAssetImage(
                      `assets/theme/black_modern_1/images/sidebar/games-provider.png`
                    )
                  "
                  alt=""
                />
                <span
                  class="relative w-full max-w-full overflow-hidden opacity-100 left-5"
                  >{{ $t("game_providers") }}</span
                >
                <font-awesome-icon
                  icon="arrow-right"
                  class="flex items-center justify-center opacity-100"
                />
              </div>
              <ul
                class="flex flex-col items-start justify-start w-full h-auto p-0"
              >
                <li
                  v-for="menu in menuTabHeaders"
                  :key="menu.TabType"
                  class="relative w-full text-[#707585] font-normal my-[6px] mx-0"
                >
                  <div
                    class="relative flex items-center w-full h-10"
                    @click="handleClickMenu(!menu.TabURL?.includes('games') ? String(menu.TabURL) : '/games/HotGames__n__gt')"
                  >
                    <img
                      v-if="!checkActiveTab(activetab, menu)"
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      :src="
                        getAssetImage(
                          `assets/theme/black_modern_1/images/sidebar/${menu?.TabType.replace(
                            ' ',
                            '-'
                          ).toLowerCase()}-b.png`
                        )
                      "
                      alt=""
                    />
                    <img
                      v-else
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      :src="
                        getAssetImage(
                          `assets/theme/black_modern_1/images/sidebar/${menu?.TabType.replace(
                            ' ',
                            '-'
                          ).toLowerCase()}-a.png`
                        )
                      "
                      alt=""
                    />
                    <span
                      :class="
                        checkActiveTab(activetab, menu)
                          ? 'text-[var(--accent-color)]'
                          : ''
                      "
                      class="relative overflow-hidden left-[52px] opacity-100 max-w-full w-[calc(100%-36px)]"
                    >
                      {{ $t(menu?.TabType.replace(" ", "_").toLowerCase()) }}
                    </span>
                  </div>
                </li>
                <li
                  class="relative w-full text-[#707585] font-normal my-[6px] mx-0"
                  v-if="isAllowPromotionTab"
                >
                  <div
                    class="relative flex items-center w-full h-10"
                    @click="handleClickMenu(String('/promotion'))"
                  >
                    <img
                      v-if="
                        activetab.replace(' ', '').toLowerCase() !== 'promotion'
                      "
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      :src="
                        getAssetImage(
                          'assets/theme/black_modern_1/images/sidebar/promotion-b.png'
                        )
                      "
                      alt=""
                    />
                    <img
                      v-else
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      :src="
                        getAssetImage(
                          'assets/theme/black_modern_1/images/sidebar/promotion-a.png'
                        )
                      "
                      alt=""
                    />
                    <span
                      :class="
                        activetab.replace(' ', '').toLowerCase() === 'promotion'
                          ? 'text-[var(--accent-color)]'
                          : ''
                      "
                      class="relative overflow-hidden left-[52px] opacity-100 max-w-full w-[calc(100%-36px)]"
                    >
                      {{ $t("promotion") }}
                    </span>
                  </div>
                </li>
                <li
                  v-if="isAppDownloadEnabled"
                  class="relative w-full text-[#707585] font-normal my-[6px] mx-0"
                >
                  <div
                    class="relative flex items-center w-full h-10"
                    @click="handleClickMenu('/app-download')"
                  >
                    <img
                      v-if="
                        activetab.replace(' ', '').toLowerCase() !==
                        'appdownload'
                      "
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      :src="
                        getAssetImage(
                          'assets/theme/black_modern_1/images/sidebar/download-b.png'
                        )
                      "
                      alt=""
                    />
                    <img
                      v-else
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      :src="
                        getAssetImage(
                          'assets/theme/black_modern_1/images/sidebar/download-a.png'
                        )
                      "
                      alt=""
                    />
                    <span
                      :class="
                        activetab.replace(' ', '').toLowerCase() ===
                        'appdownload'
                          ? 'text-[var(--accent-color)]'
                          : ''
                      "
                      class="relative overflow-hidden left-[52px] opacity-100 max-w-full w-[calc(100%-36px)]"
                    >
                      {{ $t("app_download") }}
                    </span>
                  </div>
                </li>
                <li
                  class="relative w-full text-[#707585] font-normal my-[6px] mx-0"
                >
                  <div
                    class="relative flex items-center w-full h-10"
                    @click="handleClickMenu(String('/term-condition'))"
                  >
                    <font-awesome-icon
                      v-if="
                        activetab.replace('-', '').toLowerCase() !==
                        'termcondition'
                      "
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      icon="file"
                    />
                    <font-awesome-icon
                      v-else
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                      icon="file"
                    />
                    <span
                      :class="
                        activetab.replace('-', '').toLowerCase() ===
                        'termcondition'
                          ? 'text-[var(--accent-color)]'
                          : ''
                      "
                      class="relative overflow-hidden left-[52px] opacity-100 max-w-full w-[calc(100%-36px)]"
                    >
                      {{ $t("term_and_condition") }}
                    </span>
                  </div>
                </li>
                <li
                  v-if="getContactList.length"
                  class="relative w-full text-[#707585] font-normal my-[6px] mx-0"
                >
                  <div
                    class="relative flex items-center w-full h-10"
                    @click="handleClickMenu(String('/contact-us'))"
                  >
                    <svg-icon
                      svg-name="icon-contact-new"
                      v-if="
                        activetab.replace('-', '').toLowerCase() !==
                        'contactus'
                      "
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                    />
                    <svg-icon
                      svg-name="icon-contact-new"
                      v-else
                      class="absolute w-6 h-6 text-2xl leading-normal rounded-lg left-2"
                    />
                    <span
                      :class="
                        activetab.replace('-', '').toLowerCase() ===
                        'contactus'
                          ? 'text-[var(--accent-color)]'
                          : ''
                      "
                      class="relative overflow-hidden left-[52px] opacity-100 max-w-full w-[calc(100%-36px)]"
                    >
                      {{ $t("contact") }}
                    </span>
                  </div>
                </li>
              </ul>
            </div>
          </div>
          <div
            class="w-full ml-0 flex items-center h-[40px] text-sm py-0 px-4 bg-[var(--button-bg)] border-[var(--element-border-color)] border-[1px] box-shadow rounded-lg mb-4"
            @click="dialogVisibleLang = true"
            style="min-height: 40px;"
          >
            <img
              class="w-5 h-5 align-middle border-0"
              :src="
                getAssetImage(
                  `assets/materials/languageIcon/${defaultLanguage}.svg`
                )
              "
              alt=""
            />
            <span
              class="relative w-full max-w-full overflow-hidden opacity-100 left-5"
              >{{ defaultLanguageForDisplay }}</span
            >
            <font-awesome-icon
              icon="arrow-right"
              class="flex items-center justify-center opacity-100"
            />
          </div>
          <switch-modern-theme :is-dark="isDark" @toggle="toggleDark" />
        </div>
      </div>
    </el-drawer>
  </div>
  <game-type-dialog
    v-model:game-type-dialog-visible="gameTypeDialogVisible"
    :handle-click="handleClickMenu"
  />
  <provider-dialog
    v-model:dialogVisible="dialogVisible"
    :handle-click="handleClickMenu"
  />
  <language-drawer
    v-model:dialogVisible="dialogVisibleLang"
    :languages="languages"
    :default-language-for-display="String(defaultLanguageForDisplay)"
    :switch-language="switchLanguage"
    :default-language="String(defaultLanguage)"
  />
  <search-modal :is-open="isGameSearchOpen" @close="closeGameSearchModal" />
</template>

<script lang="ts">
import { computed, defineComponent, ref, toRefs } from "vue";
import { useRoute, useRouter } from "vue-router";
import GameTypeDialog from "./game-type-dialog.client.vue";
import ProviderDialog from "./provider-dialog.client.vue";
import LanguageDrawer from "./language-drawer.client.vue";
import SearchModal from "./search-modal.client.vue";
import commonHelper from "@/utils/commonHelper";
import {
  useHeaderComponent,
  useLanguageComponent,
} from "@/composables/useTheme";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { TabInfo } from "@/models/IGetPlayableGamesResponse";
import useDarkMode from "~~/composables/theme/useDarkMode";

export default defineComponent({
  name: "Drawer",
  components: {
    GameTypeDialog,
    ProviderDialog,
    LanguageDrawer,
    SearchModal,
  },
  props: {
    showDrawer: {
      type: Boolean,
      required: true,
    },
  },
  emits: ["update:showDrawer"],
  setup(props, { emit }) {
    const route = useRoute();
    const router = useRouter();
    const activetab = computed(() => route.path.slice(1));
    const { getAssetImage } = commonHelper;
    const { getContactList } = useContactUs();
    const gameTypeDialogVisible = ref(false);
    const dialogVisible = ref(false);
    const dialogVisibleLang = ref(false);
    const checkActiveTab = (active: string, menu: TabInfo) => {
      if (route.matched[0].name === "GameInitial") {
        return active
          .replace(" ", "")
          .replace("-", "")
          .toLowerCase()
          .includes(menu?.TabType.replace(" ", "").toLowerCase());
      }
      if (route.matched[0].name !== "GameInitial") {
        return (
          active.replace(" ", "").replace("-", "").toLowerCase() ===
          menu?.TabType.replace(" ", "").toLowerCase()
        );
      }
      return false;
    };
    const {
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
    } = useLanguageComponent();
    const { menuTabHeaders, isAppDownloadEnabled, isAllowPromotionTab } = useHeaderComponent();
    const { showDrawer: drawer } = toRefs(props);
    const goHome = () => {
      emit("update:showDrawer", false);
      router.push("/");
    };
    const handleClickMenu = (path: string) => {
      emit("update:showDrawer", false);
      router.push(path);
    };
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "mini_logo"
        )
    );
    const bigLogo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "logo"
        )
    );
    const miniLogo = `url(${logo.value.ImagePath})`;
    const isGameSearchOpen = ref(false);
    const openGameSearchModal = () => {
      isGameSearchOpen.value = true;
    };
    const closeGameSearchModal = () => {
      isGameSearchOpen.value = false;
    };
    const { isDark, toggleDark } = useDarkMode;
    return {
      menuTabHeaders,
      drawer,
      getAssetImage,
      gameTypeDialogVisible,
      dialogVisible,
      dialogVisibleLang,
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
      miniLogo,
      bigLogo,
      activetab,
      handleClickMenu,
      isGameSearchOpen,
      openGameSearchModal,
      closeGameSearchModal,
      checkActiveTab,
      goHome,
      isAppDownloadEnabled,
      isDark,
      toggleDark,
      isAllowPromotionTab,
      getContactList,
    };
  },
});
</script>

<style lang="scss">
.drawer_menu {
  .drawer-menu {
    .el-drawer__body {
      padding: 0 !important;
    }
    .el-drawer__header {
      margin-bottom: 0;
      padding: 0;
    }
  }
  .el-overlay {
    z-index: 21 !important;
  }
  .logo {
    background: v-bind("miniLogo");
    display: flex;
    flex-shrink: 0;
    width: 100%;
    height: 72px;
    background-repeat: no-repeat;
    background-size: 32px;
    background-position: center left 15px;
    background-color: var(--block-bg-color);
    box-shadow: 0 4px 16px rgb(0 0 0 / 8%);
  }
}
</style>
